/*
 * Product Ordering
 *
 * **TMF API Reference : TMF 622 - Product Ordering Management**  **Release : 19.0 - June 2019**  The Product Ordering API provides a standardized mechanism for placing a product order with all of the necessary order parameters. The API consists of a simple set of operations that interact with CRM/Order Negotiation systems in a consistent manner. A product order is created based on a product offer that is defined in a catalog. The product offer identifies the product or set of products that are available to a customer, and includes characteristics such as pricing, product options and market. This API provide a task based resource to request order cancellation.  The product order references the product offer and identifies any specific requests made by the customer.  **Product Order resource** A Product Order is a type of order which can be used to place an order between a customer and a service provider or between a service provider and a partner and vice versa. Main Product Order attributes are its identifier, state, priority category (mass market, Enterprise, etc.) related dates (start, completion, etc.), related billing account, related parties and order items. Main Order Items (aka order lines) attributes are the ordered offering and product characteristics with the related action to be performed (e.g. add or delete the products), state, location information for delivery, order item price and price alteration.  Product Order API performs the following operations on product order :     -Retrieval of a product order or a collection of product orders depending on filter criteria     -Partial update of a product order (including updating rules)    -Creation of a product order (including default values and creation rules)    -Deletion of product order (for administration purposes)     -Notification of events on product order.  **cancelProductOrder resource** This resource is used to request a product order cancellation. Product Order API performs the following operations on product order :     -Retrieval of a cancel product order or a collection of cancel product orders     -Creation of a cancel product order     -Notification of events on cancel product order.   Copyright © TM Forum 2019. All Rights Reserved   
 *
 * API version: 4.0.0
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package openapi

import (
	"encoding/json"
	"time"
)

// Product A product offering procured by a customer or other interested party playing a party role. A product is realized as one or more service(s) and / or resource(s).
type Product struct {
	// Unique identifier of the product
	Id *string `json:"id,omitempty"`
	// Reference of the product
	Href *string `json:"href,omitempty"`
	// Is the description of the product. It could be copied from the description of the Product Offering.
	Description *string `json:"description,omitempty"`
	// If true, the product is a ProductBundle which is an instantiation of a BundledProductOffering. If false, the product is a ProductComponent which is an instantiation of a SimpleProductOffering.
	IsBundle *bool `json:"isBundle,omitempty"`
	// If true, the product is visible by the customer.
	IsCustomerVisible *bool `json:"isCustomerVisible,omitempty"`
	// Name of the product. It could be the same as the name of the product offering
	Name *string `json:"name,omitempty"`
	// Is the date when the product was ordered
	OrderDate *time.Time `json:"orderDate,omitempty"`
	// Is the serial number for the product. This is typically applicable to tangible products e.g. Broadband Router.
	ProductSerialNumber *string `json:"productSerialNumber,omitempty"`
	// Is the date from which the product starts
	StartDate *time.Time `json:"startDate,omitempty"`
	// Is the date when the product was terminated
	TerminationDate *time.Time `json:"terminationDate,omitempty"`
	Agreement *[]AgreementItemRef `json:"agreement,omitempty"`
	BillingAccount *BillingAccountRef `json:"billingAccount,omitempty"`
	Place *[]RelatedPlaceRefOrValue `json:"place,omitempty"`
	Product *[]ProductRefOrValue `json:"product,omitempty"`
	ProductCharacteristic *[]Characteristic `json:"productCharacteristic,omitempty"`
	ProductOffering *ProductOfferingRef `json:"productOffering,omitempty"`
	ProductOrderItem *[]RelatedProductOrderItem `json:"productOrderItem,omitempty"`
	ProductPrice *[]ProductPrice `json:"productPrice,omitempty"`
	ProductRelationship *[]ProductRelationship `json:"productRelationship,omitempty"`
	ProductSpecification *ProductSpecificationRef `json:"productSpecification,omitempty"`
	ProductTerm *[]ProductTerm `json:"productTerm,omitempty"`
	RealizingResource *[]ResourceRef `json:"realizingResource,omitempty"`
	RealizingService *[]ServiceRef `json:"realizingService,omitempty"`
	RelatedParty *[]RelatedParty `json:"relatedParty,omitempty"`
	Status *ProductStatusType `json:"status,omitempty"`
	// When sub-classing, this defines the super-class
	BaseType *string `json:"@baseType,omitempty"`
	// A URI to a JSON-Schema file that defines additional attributes and relationships
	SchemaLocation *string `json:"@schemaLocation,omitempty"`
	// When sub-classing, this defines the sub-class entity name
	Type *string `json:"@type,omitempty"`
}

// NewProduct instantiates a new Product object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewProduct() *Product {
	this := Product{}
	return &this
}

// NewProductWithDefaults instantiates a new Product object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewProductWithDefaults() *Product {
	this := Product{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *Product) GetId() string {
	if o == nil || o.Id == nil {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Product) GetIdOk() (*string, bool) {
	if o == nil || o.Id == nil {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *Product) HasId() bool {
	if o != nil && o.Id != nil {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *Product) SetId(v string) {
	o.Id = &v
}

// GetHref returns the Href field value if set, zero value otherwise.
func (o *Product) GetHref() string {
	if o == nil || o.Href == nil {
		var ret string
		return ret
	}
	return *o.Href
}

// GetHrefOk returns a tuple with the Href field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Product) GetHrefOk() (*string, bool) {
	if o == nil || o.Href == nil {
		return nil, false
	}
	return o.Href, true
}

// HasHref returns a boolean if a field has been set.
func (o *Product) HasHref() bool {
	if o != nil && o.Href != nil {
		return true
	}

	return false
}

// SetHref gets a reference to the given string and assigns it to the Href field.
func (o *Product) SetHref(v string) {
	o.Href = &v
}

// GetDescription returns the Description field value if set, zero value otherwise.
func (o *Product) GetDescription() string {
	if o == nil || o.Description == nil {
		var ret string
		return ret
	}
	return *o.Description
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Product) GetDescriptionOk() (*string, bool) {
	if o == nil || o.Description == nil {
		return nil, false
	}
	return o.Description, true
}

// HasDescription returns a boolean if a field has been set.
func (o *Product) HasDescription() bool {
	if o != nil && o.Description != nil {
		return true
	}

	return false
}

// SetDescription gets a reference to the given string and assigns it to the Description field.
func (o *Product) SetDescription(v string) {
	o.Description = &v
}

// GetIsBundle returns the IsBundle field value if set, zero value otherwise.
func (o *Product) GetIsBundle() bool {
	if o == nil || o.IsBundle == nil {
		var ret bool
		return ret
	}
	return *o.IsBundle
}

// GetIsBundleOk returns a tuple with the IsBundle field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Product) GetIsBundleOk() (*bool, bool) {
	if o == nil || o.IsBundle == nil {
		return nil, false
	}
	return o.IsBundle, true
}

// HasIsBundle returns a boolean if a field has been set.
func (o *Product) HasIsBundle() bool {
	if o != nil && o.IsBundle != nil {
		return true
	}

	return false
}

// SetIsBundle gets a reference to the given bool and assigns it to the IsBundle field.
func (o *Product) SetIsBundle(v bool) {
	o.IsBundle = &v
}

// GetIsCustomerVisible returns the IsCustomerVisible field value if set, zero value otherwise.
func (o *Product) GetIsCustomerVisible() bool {
	if o == nil || o.IsCustomerVisible == nil {
		var ret bool
		return ret
	}
	return *o.IsCustomerVisible
}

// GetIsCustomerVisibleOk returns a tuple with the IsCustomerVisible field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Product) GetIsCustomerVisibleOk() (*bool, bool) {
	if o == nil || o.IsCustomerVisible == nil {
		return nil, false
	}
	return o.IsCustomerVisible, true
}

// HasIsCustomerVisible returns a boolean if a field has been set.
func (o *Product) HasIsCustomerVisible() bool {
	if o != nil && o.IsCustomerVisible != nil {
		return true
	}

	return false
}

// SetIsCustomerVisible gets a reference to the given bool and assigns it to the IsCustomerVisible field.
func (o *Product) SetIsCustomerVisible(v bool) {
	o.IsCustomerVisible = &v
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *Product) GetName() string {
	if o == nil || o.Name == nil {
		var ret string
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Product) GetNameOk() (*string, bool) {
	if o == nil || o.Name == nil {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *Product) HasName() bool {
	if o != nil && o.Name != nil {
		return true
	}

	return false
}

// SetName gets a reference to the given string and assigns it to the Name field.
func (o *Product) SetName(v string) {
	o.Name = &v
}

// GetOrderDate returns the OrderDate field value if set, zero value otherwise.
func (o *Product) GetOrderDate() time.Time {
	if o == nil || o.OrderDate == nil {
		var ret time.Time
		return ret
	}
	return *o.OrderDate
}

// GetOrderDateOk returns a tuple with the OrderDate field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Product) GetOrderDateOk() (*time.Time, bool) {
	if o == nil || o.OrderDate == nil {
		return nil, false
	}
	return o.OrderDate, true
}

// HasOrderDate returns a boolean if a field has been set.
func (o *Product) HasOrderDate() bool {
	if o != nil && o.OrderDate != nil {
		return true
	}

	return false
}

// SetOrderDate gets a reference to the given time.Time and assigns it to the OrderDate field.
func (o *Product) SetOrderDate(v time.Time) {
	o.OrderDate = &v
}

// GetProductSerialNumber returns the ProductSerialNumber field value if set, zero value otherwise.
func (o *Product) GetProductSerialNumber() string {
	if o == nil || o.ProductSerialNumber == nil {
		var ret string
		return ret
	}
	return *o.ProductSerialNumber
}

// GetProductSerialNumberOk returns a tuple with the ProductSerialNumber field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Product) GetProductSerialNumberOk() (*string, bool) {
	if o == nil || o.ProductSerialNumber == nil {
		return nil, false
	}
	return o.ProductSerialNumber, true
}

// HasProductSerialNumber returns a boolean if a field has been set.
func (o *Product) HasProductSerialNumber() bool {
	if o != nil && o.ProductSerialNumber != nil {
		return true
	}

	return false
}

// SetProductSerialNumber gets a reference to the given string and assigns it to the ProductSerialNumber field.
func (o *Product) SetProductSerialNumber(v string) {
	o.ProductSerialNumber = &v
}

// GetStartDate returns the StartDate field value if set, zero value otherwise.
func (o *Product) GetStartDate() time.Time {
	if o == nil || o.StartDate == nil {
		var ret time.Time
		return ret
	}
	return *o.StartDate
}

// GetStartDateOk returns a tuple with the StartDate field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Product) GetStartDateOk() (*time.Time, bool) {
	if o == nil || o.StartDate == nil {
		return nil, false
	}
	return o.StartDate, true
}

// HasStartDate returns a boolean if a field has been set.
func (o *Product) HasStartDate() bool {
	if o != nil && o.StartDate != nil {
		return true
	}

	return false
}

// SetStartDate gets a reference to the given time.Time and assigns it to the StartDate field.
func (o *Product) SetStartDate(v time.Time) {
	o.StartDate = &v
}

// GetTerminationDate returns the TerminationDate field value if set, zero value otherwise.
func (o *Product) GetTerminationDate() time.Time {
	if o == nil || o.TerminationDate == nil {
		var ret time.Time
		return ret
	}
	return *o.TerminationDate
}

// GetTerminationDateOk returns a tuple with the TerminationDate field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Product) GetTerminationDateOk() (*time.Time, bool) {
	if o == nil || o.TerminationDate == nil {
		return nil, false
	}
	return o.TerminationDate, true
}

// HasTerminationDate returns a boolean if a field has been set.
func (o *Product) HasTerminationDate() bool {
	if o != nil && o.TerminationDate != nil {
		return true
	}

	return false
}

// SetTerminationDate gets a reference to the given time.Time and assigns it to the TerminationDate field.
func (o *Product) SetTerminationDate(v time.Time) {
	o.TerminationDate = &v
}

// GetAgreement returns the Agreement field value if set, zero value otherwise.
func (o *Product) GetAgreement() []AgreementItemRef {
	if o == nil || o.Agreement == nil {
		var ret []AgreementItemRef
		return ret
	}
	return *o.Agreement
}

// GetAgreementOk returns a tuple with the Agreement field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Product) GetAgreementOk() (*[]AgreementItemRef, bool) {
	if o == nil || o.Agreement == nil {
		return nil, false
	}
	return o.Agreement, true
}

// HasAgreement returns a boolean if a field has been set.
func (o *Product) HasAgreement() bool {
	if o != nil && o.Agreement != nil {
		return true
	}

	return false
}

// SetAgreement gets a reference to the given []AgreementItemRef and assigns it to the Agreement field.
func (o *Product) SetAgreement(v []AgreementItemRef) {
	o.Agreement = &v
}

// GetBillingAccount returns the BillingAccount field value if set, zero value otherwise.
func (o *Product) GetBillingAccount() BillingAccountRef {
	if o == nil || o.BillingAccount == nil {
		var ret BillingAccountRef
		return ret
	}
	return *o.BillingAccount
}

// GetBillingAccountOk returns a tuple with the BillingAccount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Product) GetBillingAccountOk() (*BillingAccountRef, bool) {
	if o == nil || o.BillingAccount == nil {
		return nil, false
	}
	return o.BillingAccount, true
}

// HasBillingAccount returns a boolean if a field has been set.
func (o *Product) HasBillingAccount() bool {
	if o != nil && o.BillingAccount != nil {
		return true
	}

	return false
}

// SetBillingAccount gets a reference to the given BillingAccountRef and assigns it to the BillingAccount field.
func (o *Product) SetBillingAccount(v BillingAccountRef) {
	o.BillingAccount = &v
}

// GetPlace returns the Place field value if set, zero value otherwise.
func (o *Product) GetPlace() []RelatedPlaceRefOrValue {
	if o == nil || o.Place == nil {
		var ret []RelatedPlaceRefOrValue
		return ret
	}
	return *o.Place
}

// GetPlaceOk returns a tuple with the Place field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Product) GetPlaceOk() (*[]RelatedPlaceRefOrValue, bool) {
	if o == nil || o.Place == nil {
		return nil, false
	}
	return o.Place, true
}

// HasPlace returns a boolean if a field has been set.
func (o *Product) HasPlace() bool {
	if o != nil && o.Place != nil {
		return true
	}

	return false
}

// SetPlace gets a reference to the given []RelatedPlaceRefOrValue and assigns it to the Place field.
func (o *Product) SetPlace(v []RelatedPlaceRefOrValue) {
	o.Place = &v
}

// GetProduct returns the Product field value if set, zero value otherwise.
func (o *Product) GetProduct() []ProductRefOrValue {
	if o == nil || o.Product == nil {
		var ret []ProductRefOrValue
		return ret
	}
	return *o.Product
}

// GetProductOk returns a tuple with the Product field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Product) GetProductOk() (*[]ProductRefOrValue, bool) {
	if o == nil || o.Product == nil {
		return nil, false
	}
	return o.Product, true
}

// HasProduct returns a boolean if a field has been set.
func (o *Product) HasProduct() bool {
	if o != nil && o.Product != nil {
		return true
	}

	return false
}

// SetProduct gets a reference to the given []ProductRefOrValue and assigns it to the Product field.
func (o *Product) SetProduct(v []ProductRefOrValue) {
	o.Product = &v
}

// GetProductCharacteristic returns the ProductCharacteristic field value if set, zero value otherwise.
func (o *Product) GetProductCharacteristic() []Characteristic {
	if o == nil || o.ProductCharacteristic == nil {
		var ret []Characteristic
		return ret
	}
	return *o.ProductCharacteristic
}

// GetProductCharacteristicOk returns a tuple with the ProductCharacteristic field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Product) GetProductCharacteristicOk() (*[]Characteristic, bool) {
	if o == nil || o.ProductCharacteristic == nil {
		return nil, false
	}
	return o.ProductCharacteristic, true
}

// HasProductCharacteristic returns a boolean if a field has been set.
func (o *Product) HasProductCharacteristic() bool {
	if o != nil && o.ProductCharacteristic != nil {
		return true
	}

	return false
}

// SetProductCharacteristic gets a reference to the given []Characteristic and assigns it to the ProductCharacteristic field.
func (o *Product) SetProductCharacteristic(v []Characteristic) {
	o.ProductCharacteristic = &v
}

// GetProductOffering returns the ProductOffering field value if set, zero value otherwise.
func (o *Product) GetProductOffering() ProductOfferingRef {
	if o == nil || o.ProductOffering == nil {
		var ret ProductOfferingRef
		return ret
	}
	return *o.ProductOffering
}

// GetProductOfferingOk returns a tuple with the ProductOffering field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Product) GetProductOfferingOk() (*ProductOfferingRef, bool) {
	if o == nil || o.ProductOffering == nil {
		return nil, false
	}
	return o.ProductOffering, true
}

// HasProductOffering returns a boolean if a field has been set.
func (o *Product) HasProductOffering() bool {
	if o != nil && o.ProductOffering != nil {
		return true
	}

	return false
}

// SetProductOffering gets a reference to the given ProductOfferingRef and assigns it to the ProductOffering field.
func (o *Product) SetProductOffering(v ProductOfferingRef) {
	o.ProductOffering = &v
}

// GetProductOrderItem returns the ProductOrderItem field value if set, zero value otherwise.
func (o *Product) GetProductOrderItem() []RelatedProductOrderItem {
	if o == nil || o.ProductOrderItem == nil {
		var ret []RelatedProductOrderItem
		return ret
	}
	return *o.ProductOrderItem
}

// GetProductOrderItemOk returns a tuple with the ProductOrderItem field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Product) GetProductOrderItemOk() (*[]RelatedProductOrderItem, bool) {
	if o == nil || o.ProductOrderItem == nil {
		return nil, false
	}
	return o.ProductOrderItem, true
}

// HasProductOrderItem returns a boolean if a field has been set.
func (o *Product) HasProductOrderItem() bool {
	if o != nil && o.ProductOrderItem != nil {
		return true
	}

	return false
}

// SetProductOrderItem gets a reference to the given []RelatedProductOrderItem and assigns it to the ProductOrderItem field.
func (o *Product) SetProductOrderItem(v []RelatedProductOrderItem) {
	o.ProductOrderItem = &v
}

// GetProductPrice returns the ProductPrice field value if set, zero value otherwise.
func (o *Product) GetProductPrice() []ProductPrice {
	if o == nil || o.ProductPrice == nil {
		var ret []ProductPrice
		return ret
	}
	return *o.ProductPrice
}

// GetProductPriceOk returns a tuple with the ProductPrice field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Product) GetProductPriceOk() (*[]ProductPrice, bool) {
	if o == nil || o.ProductPrice == nil {
		return nil, false
	}
	return o.ProductPrice, true
}

// HasProductPrice returns a boolean if a field has been set.
func (o *Product) HasProductPrice() bool {
	if o != nil && o.ProductPrice != nil {
		return true
	}

	return false
}

// SetProductPrice gets a reference to the given []ProductPrice and assigns it to the ProductPrice field.
func (o *Product) SetProductPrice(v []ProductPrice) {
	o.ProductPrice = &v
}

// GetProductRelationship returns the ProductRelationship field value if set, zero value otherwise.
func (o *Product) GetProductRelationship() []ProductRelationship {
	if o == nil || o.ProductRelationship == nil {
		var ret []ProductRelationship
		return ret
	}
	return *o.ProductRelationship
}

// GetProductRelationshipOk returns a tuple with the ProductRelationship field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Product) GetProductRelationshipOk() (*[]ProductRelationship, bool) {
	if o == nil || o.ProductRelationship == nil {
		return nil, false
	}
	return o.ProductRelationship, true
}

// HasProductRelationship returns a boolean if a field has been set.
func (o *Product) HasProductRelationship() bool {
	if o != nil && o.ProductRelationship != nil {
		return true
	}

	return false
}

// SetProductRelationship gets a reference to the given []ProductRelationship and assigns it to the ProductRelationship field.
func (o *Product) SetProductRelationship(v []ProductRelationship) {
	o.ProductRelationship = &v
}

// GetProductSpecification returns the ProductSpecification field value if set, zero value otherwise.
func (o *Product) GetProductSpecification() ProductSpecificationRef {
	if o == nil || o.ProductSpecification == nil {
		var ret ProductSpecificationRef
		return ret
	}
	return *o.ProductSpecification
}

// GetProductSpecificationOk returns a tuple with the ProductSpecification field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Product) GetProductSpecificationOk() (*ProductSpecificationRef, bool) {
	if o == nil || o.ProductSpecification == nil {
		return nil, false
	}
	return o.ProductSpecification, true
}

// HasProductSpecification returns a boolean if a field has been set.
func (o *Product) HasProductSpecification() bool {
	if o != nil && o.ProductSpecification != nil {
		return true
	}

	return false
}

// SetProductSpecification gets a reference to the given ProductSpecificationRef and assigns it to the ProductSpecification field.
func (o *Product) SetProductSpecification(v ProductSpecificationRef) {
	o.ProductSpecification = &v
}

// GetProductTerm returns the ProductTerm field value if set, zero value otherwise.
func (o *Product) GetProductTerm() []ProductTerm {
	if o == nil || o.ProductTerm == nil {
		var ret []ProductTerm
		return ret
	}
	return *o.ProductTerm
}

// GetProductTermOk returns a tuple with the ProductTerm field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Product) GetProductTermOk() (*[]ProductTerm, bool) {
	if o == nil || o.ProductTerm == nil {
		return nil, false
	}
	return o.ProductTerm, true
}

// HasProductTerm returns a boolean if a field has been set.
func (o *Product) HasProductTerm() bool {
	if o != nil && o.ProductTerm != nil {
		return true
	}

	return false
}

// SetProductTerm gets a reference to the given []ProductTerm and assigns it to the ProductTerm field.
func (o *Product) SetProductTerm(v []ProductTerm) {
	o.ProductTerm = &v
}

// GetRealizingResource returns the RealizingResource field value if set, zero value otherwise.
func (o *Product) GetRealizingResource() []ResourceRef {
	if o == nil || o.RealizingResource == nil {
		var ret []ResourceRef
		return ret
	}
	return *o.RealizingResource
}

// GetRealizingResourceOk returns a tuple with the RealizingResource field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Product) GetRealizingResourceOk() (*[]ResourceRef, bool) {
	if o == nil || o.RealizingResource == nil {
		return nil, false
	}
	return o.RealizingResource, true
}

// HasRealizingResource returns a boolean if a field has been set.
func (o *Product) HasRealizingResource() bool {
	if o != nil && o.RealizingResource != nil {
		return true
	}

	return false
}

// SetRealizingResource gets a reference to the given []ResourceRef and assigns it to the RealizingResource field.
func (o *Product) SetRealizingResource(v []ResourceRef) {
	o.RealizingResource = &v
}

// GetRealizingService returns the RealizingService field value if set, zero value otherwise.
func (o *Product) GetRealizingService() []ServiceRef {
	if o == nil || o.RealizingService == nil {
		var ret []ServiceRef
		return ret
	}
	return *o.RealizingService
}

// GetRealizingServiceOk returns a tuple with the RealizingService field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Product) GetRealizingServiceOk() (*[]ServiceRef, bool) {
	if o == nil || o.RealizingService == nil {
		return nil, false
	}
	return o.RealizingService, true
}

// HasRealizingService returns a boolean if a field has been set.
func (o *Product) HasRealizingService() bool {
	if o != nil && o.RealizingService != nil {
		return true
	}

	return false
}

// SetRealizingService gets a reference to the given []ServiceRef and assigns it to the RealizingService field.
func (o *Product) SetRealizingService(v []ServiceRef) {
	o.RealizingService = &v
}

// GetRelatedParty returns the RelatedParty field value if set, zero value otherwise.
func (o *Product) GetRelatedParty() []RelatedParty {
	if o == nil || o.RelatedParty == nil {
		var ret []RelatedParty
		return ret
	}
	return *o.RelatedParty
}

// GetRelatedPartyOk returns a tuple with the RelatedParty field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Product) GetRelatedPartyOk() (*[]RelatedParty, bool) {
	if o == nil || o.RelatedParty == nil {
		return nil, false
	}
	return o.RelatedParty, true
}

// HasRelatedParty returns a boolean if a field has been set.
func (o *Product) HasRelatedParty() bool {
	if o != nil && o.RelatedParty != nil {
		return true
	}

	return false
}

// SetRelatedParty gets a reference to the given []RelatedParty and assigns it to the RelatedParty field.
func (o *Product) SetRelatedParty(v []RelatedParty) {
	o.RelatedParty = &v
}

// GetStatus returns the Status field value if set, zero value otherwise.
func (o *Product) GetStatus() ProductStatusType {
	if o == nil || o.Status == nil {
		var ret ProductStatusType
		return ret
	}
	return *o.Status
}

// GetStatusOk returns a tuple with the Status field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Product) GetStatusOk() (*ProductStatusType, bool) {
	if o == nil || o.Status == nil {
		return nil, false
	}
	return o.Status, true
}

// HasStatus returns a boolean if a field has been set.
func (o *Product) HasStatus() bool {
	if o != nil && o.Status != nil {
		return true
	}

	return false
}

// SetStatus gets a reference to the given ProductStatusType and assigns it to the Status field.
func (o *Product) SetStatus(v ProductStatusType) {
	o.Status = &v
}

// GetBaseType returns the BaseType field value if set, zero value otherwise.
func (o *Product) GetBaseType() string {
	if o == nil || o.BaseType == nil {
		var ret string
		return ret
	}
	return *o.BaseType
}

// GetBaseTypeOk returns a tuple with the BaseType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Product) GetBaseTypeOk() (*string, bool) {
	if o == nil || o.BaseType == nil {
		return nil, false
	}
	return o.BaseType, true
}

// HasBaseType returns a boolean if a field has been set.
func (o *Product) HasBaseType() bool {
	if o != nil && o.BaseType != nil {
		return true
	}

	return false
}

// SetBaseType gets a reference to the given string and assigns it to the BaseType field.
func (o *Product) SetBaseType(v string) {
	o.BaseType = &v
}

// GetSchemaLocation returns the SchemaLocation field value if set, zero value otherwise.
func (o *Product) GetSchemaLocation() string {
	if o == nil || o.SchemaLocation == nil {
		var ret string
		return ret
	}
	return *o.SchemaLocation
}

// GetSchemaLocationOk returns a tuple with the SchemaLocation field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Product) GetSchemaLocationOk() (*string, bool) {
	if o == nil || o.SchemaLocation == nil {
		return nil, false
	}
	return o.SchemaLocation, true
}

// HasSchemaLocation returns a boolean if a field has been set.
func (o *Product) HasSchemaLocation() bool {
	if o != nil && o.SchemaLocation != nil {
		return true
	}

	return false
}

// SetSchemaLocation gets a reference to the given string and assigns it to the SchemaLocation field.
func (o *Product) SetSchemaLocation(v string) {
	o.SchemaLocation = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *Product) GetType() string {
	if o == nil || o.Type == nil {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Product) GetTypeOk() (*string, bool) {
	if o == nil || o.Type == nil {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *Product) HasType() bool {
	if o != nil && o.Type != nil {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *Product) SetType(v string) {
	o.Type = &v
}

func (o Product) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Id != nil {
		toSerialize["id"] = o.Id
	}
	if o.Href != nil {
		toSerialize["href"] = o.Href
	}
	if o.Description != nil {
		toSerialize["description"] = o.Description
	}
	if o.IsBundle != nil {
		toSerialize["isBundle"] = o.IsBundle
	}
	if o.IsCustomerVisible != nil {
		toSerialize["isCustomerVisible"] = o.IsCustomerVisible
	}
	if o.Name != nil {
		toSerialize["name"] = o.Name
	}
	if o.OrderDate != nil {
		toSerialize["orderDate"] = o.OrderDate
	}
	if o.ProductSerialNumber != nil {
		toSerialize["productSerialNumber"] = o.ProductSerialNumber
	}
	if o.StartDate != nil {
		toSerialize["startDate"] = o.StartDate
	}
	if o.TerminationDate != nil {
		toSerialize["terminationDate"] = o.TerminationDate
	}
	if o.Agreement != nil {
		toSerialize["agreement"] = o.Agreement
	}
	if o.BillingAccount != nil {
		toSerialize["billingAccount"] = o.BillingAccount
	}
	if o.Place != nil {
		toSerialize["place"] = o.Place
	}
	if o.Product != nil {
		toSerialize["product"] = o.Product
	}
	if o.ProductCharacteristic != nil {
		toSerialize["productCharacteristic"] = o.ProductCharacteristic
	}
	if o.ProductOffering != nil {
		toSerialize["productOffering"] = o.ProductOffering
	}
	if o.ProductOrderItem != nil {
		toSerialize["productOrderItem"] = o.ProductOrderItem
	}
	if o.ProductPrice != nil {
		toSerialize["productPrice"] = o.ProductPrice
	}
	if o.ProductRelationship != nil {
		toSerialize["productRelationship"] = o.ProductRelationship
	}
	if o.ProductSpecification != nil {
		toSerialize["productSpecification"] = o.ProductSpecification
	}
	if o.ProductTerm != nil {
		toSerialize["productTerm"] = o.ProductTerm
	}
	if o.RealizingResource != nil {
		toSerialize["realizingResource"] = o.RealizingResource
	}
	if o.RealizingService != nil {
		toSerialize["realizingService"] = o.RealizingService
	}
	if o.RelatedParty != nil {
		toSerialize["relatedParty"] = o.RelatedParty
	}
	if o.Status != nil {
		toSerialize["status"] = o.Status
	}
	if o.BaseType != nil {
		toSerialize["@baseType"] = o.BaseType
	}
	if o.SchemaLocation != nil {
		toSerialize["@schemaLocation"] = o.SchemaLocation
	}
	if o.Type != nil {
		toSerialize["@type"] = o.Type
	}
	return json.Marshal(toSerialize)
}

type NullableProduct struct {
	value *Product
	isSet bool
}

func (v NullableProduct) Get() *Product {
	return v.value
}

func (v *NullableProduct) Set(val *Product) {
	v.value = val
	v.isSet = true
}

func (v NullableProduct) IsSet() bool {
	return v.isSet
}

func (v *NullableProduct) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableProduct(val *Product) *NullableProduct {
	return &NullableProduct{value: val, isSet: true}
}

func (v NullableProduct) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableProduct) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


